%define major 1
%define libname	%mklibname %{name} %{major}
%define libnamedevel %mklibname %{name} -d
%define libnamestaticdevel %mklibname %{name} -d -s

%define _program_prefix eu-

%ifarch %{sunsparc}
%define	build_check		1
%else
%define build_check		1
%endif
%{expand: %{?_without_CHECK:	%%global build_check 0}}
%{expand: %{?_with_CHECK:	%%global build_check 1}}

%define build_compat		0
%if %{mdkversion} < 1010
%define build_compat		1
%endif
%{expand: %{?_without_COMPAT:	%%global build_compat 0}}
%{expand: %{?_with_COMPAT:	%%global build_compat 1}}

Summary:	A collection of utilities and DSOs to handle compiled objects
Name:		elfutils
Version:	0.146
Release:	%mkrel 1
License:	GPLv2+
Group:		Development/Other
Url:		http://fedorahosted.org/elfutils/
Source0:	http://fedorahosted.org/releases/e/l/elfutils/%{name}-%{version}.tar.bz2
Source1:	%{SOURCE0}.sig
# these 2 patches are from ftp://sources.redhat.com/pub/systemtap/elfutils/ 
Patch0:		elfutils-portability.patch
Patch1:		elfutils-robustify.patch

# mdv patches
Patch10:	elfutils-0.145-mips_backend.patch
Patch11:	elfutils-0.139-sparc-align.patch
Patch12:	elfutils-0.139-fix-special-sparc-elf32-plt-entries.patch
Requires:	%{libname} = %{version}-%{release}
%if %{build_compat}
BuildRequires:	gcc >= 3.2
%else
BuildRequires:	gcc >= 3.4
%endif
BuildRequires:	bison
BuildRequires:	flex
BuildRequires:	glibc-devel
BuildRequires:	zlib-devel
BuildRequires:	bzip2-devel
BuildRequires:	lzma-devel
BuildRequires:	gettext-devel
BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot

%description
Elfutils is a collection of utilities, including ld (a linker),
nm (for listing symbols from object files), size (for listing the
section sizes of an object or archive file), strip (for discarding
symbols), readelf (to see the raw ELF file structures), and elflint
(to check for well-formed ELF files).

%package -n %{libnamedevel}
Summary:	Development libraries to handle compiled objects
Group:		Development/Other
Requires:	%{libname} = %{version}-%{release}
Provides:	%{name}-devel 
Provides:	lib%{name}-devel
Obsoletes:	libelf-devel < 0.137
Obsoletes:	libelf0-devel < 0.137
Obsoletes:	%{_lib}%{name}1-devel < 0.137
Provides:	libelf-devel libelf0-devel

%description -n	%{libnamedevel}
This package contains the headers and dynamic libraries to create
applications for handling compiled objects.

   * libelf allows you to access the internals of the ELF object file
     format, so you can see the different sections of an ELF file.
   * libebl provides some higher-level ELF access functionality.
   * libasm provides a programmable assembler interface.

%package -n %{libnamestaticdevel}
Summary:	Static libraries for development with libelfutils
Group:		Development/Other
Requires:	%{libnamedevel} = %{version}-%{release}
Provides:	%{name}-static-devel 
Obsoletes:	libelf-static-devel < 0.137
Obsoletes:	libelf0-static-devel < 0.137
Provides:	libelf-static-devel
Provides:	libelf0-static-devel
Obsoletes:	%{_lib}%{name}1-static-devel < 0.137

%description -n	%{libnamestaticdevel}
This package contains the static libraries to create applications for
handling compiled objects.

%package -n %{libname}
Summary:	Libraries to read and write ELF files
Group:		System/Libraries
Provides:	lib%{name}
Obsoletes:	libelf < 0.137
Obsoletes:	libelf0 < 0.137
Provides:	libelf
Provides:	libelf0

%description -n	%{libname}
This package provides DSOs which allow reading and writing ELF files
on a high level.  Third party programs depend on this package to read
internals of ELF files.  The programs of the elfutils package use it
also to generate new ELF files.

Also included are numerous helper libraries which implement DWARF,
ELF, and machine-specific ELF handling.

%prep
%setup -q
%if %{build_compat}
%patch0 -p1 -b .portability~
sleep 1
find . \( -name Makefile.in -o -name aclocal.m4 \) -print | xargs touch
sleep 1
find . \( -name configure -o -name config.h.in \) -print | xargs touch
%endif

%patch1 -p1 -b .robustify~
%patch10 -p1 -b .mips~
%patch11 -p1 -b .sparc_align~
%patch12 -p1 -b .sparc_elf32_plt~

# Don't use -Werror with -Wformat=2 -std=gnu99 as %a[ won't be caught
# as the GNU %a extension.
perl -pi -e '/AM_CFLAGS =/ and s/-Werror//g' ./tests/Makefile.{in,am}

%build
autoreconf -fiv

mkdir build-%{_target_platform}
pushd build-%{_target_platform}

# [pixel] libld_elf_i386.so is quite weird, could be dropped? workarounding for now...
%define _disable_ld_no_undefined 1

CONFIGURE_TOP=.. \
%configure2_5x \
	%{?_program_prefix: --program-prefix=%{_program_prefix}} \
	--enable-thread-safety \
	--with-zlib \
	--with-bzlib \
	--with-lzma

%make
popd

%check
%if %{build_check}
pushd build-%{_target_platform}
%make check || :
popd
%endif

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}%{_prefix}

%makeinstall_std -C build-%{_target_platform}

chmod +x %{buildroot}%{_libdir}/lib*.so*
chmod +x %{buildroot}%{_libdir}/elfutils/lib*.so*

%find_lang %{name}

# XXX Nuke unpackaged files
{ cd %{buildroot}
  rm -f .%{_bindir}/eu-ld
}

%clean
rm -rf %{buildroot}

%if %mdkversion < 200900
%post -n %{libname} -p /sbin/ldconfig
%endif
%if %mdkversion < 200900
%postun -n %{libname} -p /sbin/ldconfig
%endif

%files -f %{name}.lang
%defattr(-,root,root)
%doc NOTES README NEWS TODO
%{_bindir}/eu-*
%{_libdir}/libdw-%{version}.so
%{_libdir}/libdw*.so.*
%{_libdir}/libasm-%{version}.so
%{_libdir}/libasm*.so.*
%dir %{_libdir}/elfutils
%{_libdir}/elfutils/lib*.so

%files -n %{libnamedevel}
%defattr(-,root,root)
%{_includedir}/dwarf.h
%{_includedir}/libelf.h
%{_includedir}/gelf.h
%{_includedir}/nlist.h
%dir %{_includedir}/elfutils
%{_includedir}/elfutils/*.h
%{_libdir}/libelf.so
%{_libdir}/libdw.so
%{_libdir}/libasm.so

%files -n %{libnamestaticdevel}
%defattr(-,root,root)
%{_libdir}/*.a

%files -n %{libname}
%defattr(-,root,root)
%{_libdir}/libelf-%{version}.so
%{_libdir}/libelf*.so.%{major}*


%changelog
* Wed Apr 28 2010 Emmanuel Andry <eandry@mandriva.org> 0.146-1mdv2010.1
+ Revision: 540498
- New version 0.146
- update p0 and p1
- BR gettext-devel
- update files list

* Sat Apr 03 2010 Tomasz Pawel Gajc <tpg@mandriva.org> 0.145-1mdv2010.1
+ Revision: 530871
- update to new version 0.145
- rediff patch 10

* Mon Feb 01 2010 Tomasz Pawel Gajc <tpg@mandriva.org> 0.144-1mdv2010.1
+ Revision: 499243
- update to new version 0.144

* Wed Sep 23 2009 Tomasz Pawel Gajc <tpg@mandriva.org> 0.143-1mdv2010.0
+ Revision: 448079
- enable support for lzma
- update to new version 0.143
- update robustify and portability patches

* Sat Aug 01 2009 Tomasz Pawel Gajc <tpg@mandriva.org> 0.142-1mdv2010.0
+ Revision: 407145
- update portability and robustify patches
- adapt mips patch to the latest elfutils changes
- update to new version 0.142

* Sat May 02 2009 Tomasz Pawel Gajc <tpg@mandriva.org> 0.141-1mdv2010.0
+ Revision: 370677
- update to new version 0.141

* Fri Feb 20 2009 Tomasz Pawel Gajc <tpg@mandriva.org> 0.140-1mdv2009.1
+ Revision: 343294
- update patch 0 and 1

  + Per Øyvind Karlsen <peroyvind@mandriva.org>
    - new release: 0.140
    - add back sparc patches which were previously dropped due to laziness by others:/
    - add mips backend (P10 from 2008.1 Gdium tree)

* Sat Jan 24 2009 Tomasz Pawel Gajc <tpg@mandriva.org> 0.139-1mdv2009.1
+ Revision: 333340
- enable thread safety (TLS)
- add buildrequires on zlib-devel and bzip2-devel, since libdwfl can auto-decompress ELF files
- Patch 0 and 1: update to 0.139
- drop patch2, merged upstream
- update to new version 0.139

* Sat Jan 03 2009 Tomasz Pawel Gajc <tpg@mandriva.org> 0.138-1mdv2009.1
+ Revision: 323566
- Patch1: new version
- Patch2: fix regression introduced in elfutils-0.138
- better description
- update to new version 0.138

* Mon Dec 29 2008 Oden Eriksson <oeriksson@mandriva.com> 0.137-2mdv2009.1
+ Revision: 321096
- rebuild

* Wed Sep 03 2008 Tomasz Pawel Gajc <tpg@mandriva.org> 0.137-1mdv2009.0
+ Revision: 279399
- Patch 0 and 1: new versions
- obsolete older versions than 0.137
- run autoreconf, needed by portability patch
- drop additional tests, sources 2 and 3
- update to new version 0.137
- add sig file
- reorder sources

* Wed Aug 06 2008 Thierry Vignaud <tv@mandriva.org> 0.135-2mdv2009.0
+ Revision: 264438
- rebuild early 2009.0 package (before pixel changes)

  + Pixel <pixel@mandriva.com>
    - do not call ldconfig in %%post/%%postun, it is now handled by filetriggers
    - set %%_disable_ld_no_undefined (needed by libld_elf_i386.so) instead of messing LDFLAGS

* Sun May 25 2008 Tomasz Pawel Gajc <tpg@mandriva.org> 0.135-1mdv2009.0
+ Revision: 211246
- update to new version 0.135
- drop all patches excluding patch 0 and 1
- re-define LDFLAGS
- package libasm
- package eu-objdump program
- fix file list

* Sun Feb 10 2008 Tomasz Pawel Gajc <tpg@mandriva.org> 0.131-2mdv2008.1
+ Revision: 164990
- rebuild

* Sun Dec 30 2007 Tomasz Pawel Gajc <tpg@mandriva.org> 0.131-1mdv2008.1
+ Revision: 139413
- add two test files (Source 1 and 2)
- provide updated version of patch 6  (gnu_inline)
- fix mem leak with patch 9
- provide patches 10 and 11 (minor upstream fixes)
- patch 8 has been merged upstream
- drop useles buildrequires on sharutils and libtool-devel (?)
- add buildrequires on bison and flex
- new program: eu-make-debug-archive
- spec file clean
- correct Source0
- new version 0.131
- update upstream patches 0,1,2

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Thierry Vignaud <tv@mandriva.org>
    - kill re-definition of %%buildroot on Pixel's request

* Sat Jul 14 2007 Tomasz Pawel Gajc <tpg@mandriva.org> 0.128-1mdv2008.0
+ Revision: 52067
- new program: eu-strip
- remove dead entries in spec file
- correct libification
- correct patch order
- provide patch 6 (gnu_inline)
- provide patches 7 and 8 (minor fixes)
- new version 0.128

* Thu Jun 21 2007 Olivier Thauvin <nanardon@mandriva.org> 2mdv2008.0-current
+ Revision: 42294
- don't redefine _gnu to nil
- apply new devel policy

* Fri Jun 08 2007 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 0.127-1mdv2008.0
+ Revision: 37513
- Updated to version 0.127.
- Added updated upstream versions of patches portability and robustify
  (fedora).

* Thu May 03 2007 Per Øyvind Karlsen <peroyvind@mandriva.org> 0.126-1mdv2008.0
+ Revision: 20819
- new release: 0.126
- sync patches with fedora


* Sat Jan 27 2007 Per Øyvind Karlsen <pkarlsen@mandriva.com> 0.125-2mdv2007.0
+ Revision: 114272
- elfutils should now work on sparc! :)
- support special case of SPARC ELF32 PLT entires (P6 from PLD)
- allocated pointers need 8-byte alignment on sparc (to use ldd/std opcodes to access 8-byte aligned structs) (P5 from PLD)

* Thu Jan 25 2007 Per Øyvind Karlsen <pkarlsen@mandriva.com> 0.125-1mdv2007.1
+ Revision: 113565
- check fails on other archs than sparc too, enable it for all but make failure non-fatal
- reenable check (except for sparc)
- new release: 0.125
- Fix overeager warn_unused_result build failures. (P3 from fedora)
- eu-strip -f: copy symtab into debuginfo file when relocs use it (P4 from fedora, RHBZ #203000)

* Tue Oct 31 2006 Oden Eriksson <oeriksson@mandriva.com> 0.120-3mdv2007.1
+ Revision: 74664
- bunzip patches
- Import elfutils

* Mon May 15 2006 Stefan van der Eijk <stefan@eijk.nu> 0.120-2mdk
- rebuild for sparc

* Wed Apr 19 2006 Per Øyvind Karlsen <pkarlsen@mandriva.com> 0.120-1mdk
- 0.120
- update robustification patch (P1)
- fix sparc build (P2)
- License has been changed to GPL, except for libraries which is still OSL
- move check to %%check stage
- disable checks on sparc

* Thu Apr 06 2006 Per Øyvind Karlsen <pkarlsen@mandriva.com> 0.119-2mdk
- add robustification patch (P1) from fedora
- don't give errors on compile warnings on sparc

* Fri Jan 27 2006 Per Øyvind Karlsen <pkarlsen@mandriva.com> 0.119-1mdk
- 0.119
- %%mkrel

* Wed Dec 28 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 0.118-1mdk
- 0.118

* Wed Jul 27 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 0.109-1mdk
- 0.109

* Thu Feb 17 2005 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 0.99-1mdk
- 0.99

* Sun Jan 23 2005 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 0.97-1mdk
- 0.97
- fix summary-ended-with-dot

* Sat Sep 18 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.96-1mdk
- 0.96

